<template>
  <!-- 
    普通编辑窗体
    v 1.2
    2021-04-30
    Lufthafen
  -->
  <a-form-model :model="form" :rules="rules" class="yo-form" ref="form">
    <a-spin :spinning="loading">
      <a-icon slot="indicator" spin type="loading" />
      <div class="yo-form-group">
        <!-- 表单控件 -->
        <!-- ... -->
        <a-form-model-item label="应用名称" prop="name">
          <a-input placeholder="请输入应用名称" v-model="form.name" />
        </a-form-model-item>
        <a-form-model-item label="唯一编码" prop="code">
          <a-input placeholder="请输入唯一编码" v-model="form.code" />
        </a-form-model-item>
        <a-form-model-item label="图标" prop="icon">
          <a-input :disabled="true" placeholder="请选择图标" v-model="form.icon">
            <a-icon :type="form.icon" slot="addonBefore" v-if="form.icon" />
            <a-icon @click="onOpenSelectIcon" slot="addonAfter" type="setting" />
          </a-input>
        </a-form-model-item>
        <a-form-model-item label="图标颜色" prop="color">
          <chrome-picker v-model="form.color" />
        </a-form-model-item>
        <a-form-model-item label="排序" prop="sort">
          <a-input-number
            :max="1000"
            :min="0"
            class="w-100-p"
            placeholder="请输入排序"
            v-model="form.sort"
          />
        </a-form-model-item>
      </div>
    </a-spin>

    <yo-icon-selector ref="icon-selector" v-model="form.icon" />
  </a-form-model>
</template>
<script>
import YoIconSelector from '@/components/yoIconSelector';
import { Chrome } from 'vue-color';

/* 表单内容默认值 */
const defaultForm = {
  /* ... */
  color: '#ffffff',
  active: false,
};

export default {
  components: {
    YoIconSelector,
    ChromePicker: Chrome,
  },

  data() {
    return {
      /** 表单数据 */
      form: {
        ...defaultForm,
      },
      /** 验证格式 */
      rules: {
        /* ... */
        name: [{ required: true, message: '请输入应用名称' }],
        code: [{ required: true, message: '请输入唯一编码' }],
      },

      /** 加载异步数据状态 */
      loading: false,

      /** 其他成员属性 */
      /* ... */
    };
  },

  methods: {
    /**
     * 必要的方法
     * 在打开编辑页时允许填充数据
     */
    onFillData(params) {
      /** 将默认数据覆盖到form */
      this.form = this.$_.cloneDeep({
        ...defaultForm,
        ...params.record,
        /** 在此处添加其他默认数据转换 */
        /* ... */
      });
    },

    /**
     * 必要方法
     * 验证表单并获取表单数据
     */
    onGetData() {
      return new Promise((reslove, reject) => {
        this.$refs.form.validate((valid) => {
          if (valid) {
            const record = this.$_.cloneDeep(this.form);

            /** 验证通过后可以对数据进行转换得到想要提交的格式 */
            /* ... */
            record.color = record.color.constructor === Object ? record.color.hex : record.color;

            reslove(record);
          } else {
            reject();
          }
        });
      });
    },

    /**
     * 必要的方法
     * 在外部窗口进行保存时调用表单验证
     */
    onValidate(callback) {
      this.$refs.form.validate(callback);
    },

    /**
     * 必要的方法
     * 在外部窗口关闭或重置时对表单验证进行初始化
     */
    onResetFields() {
      setTimeout(() => {
        this.$refs.form.resetFields();

        /** 在这里可以初始化当前组件中其他属性 */
        /* ... */
      }, 300);
    },

    /**
     * 必要方法
     * 加载当前表单中所需要的异步数据
     */
    async onInit(params) {
      this.loading = true;
      /** 可以在这里await获取一些异步数据 */
      /* ... */
      this.loading = false;
    },

    /** 当前组件的其他方法 */
    /* ... */
    onOpenSelectIcon() {
      this.$refs['icon-selector'].onOpen(this.form.icon);
    },
  },
};
</script>